#ifndef _stopwatch_h
#define _stopwatch_h

#include <sys/time.h>

#define TIME_RESET	0x8000

inline unsigned long TimeValToMsec ( struct timeval *tv )
    {   return tv->tv_sec * 1000 + tv->tv_usec / 1000 ; }

extern void StartTimer ( struct timeval *start_tv ) ;
extern void DiffTime ( struct timeval *start_tv, struct timeval *end_tv, struct timeval *diff_tv ) ;
extern void ElapsedTime ( struct timeval *start_tv, struct timeval *diff_tv, int info ) ;
extern void ElapsedMessage ( struct timeval *start_tv, char *name, int info ) ;

#ifdef __cplusplus
extern unsigned long DiffTime ( struct timeval *start_tv, struct timeval *end_tv ) ;
extern unsigned long ElapsedTime ( struct timeval *start_tv, int info = 0 ) ;
extern void ElapsedMessage ( struct timeval *base_tv, struct timeval *start_tv, char *name, int info = 0 ) ;
#endif	// __cplusplus

#ifndef __PPC__
extern void TimerMessage ( struct timeval *start_tv, char *name, unsigned items ) ;
#endif


#if ENABLE_STOPWATCH
#if ENABLE_STOPWATCH_DM
	#define _StartWatch()		do { 													\
									struct timeval start_tv; StartTimer ( &start_tv )
	#define _StopWatch(mesg)		ElapsedMessage ( &start_tv, mesg, 30 ) ;			\
								} while(0)
#else
	#define _StartWatch()		struct timeval start_tv; \
								StartTimer ( &start_tv )
	#define _StartWatch1()		StartTimer ( &start_tv )
	#define _StopWatch(mesg)	ElapsedMessage ( &start_tv, mesg, 30 )

 	#define _Timer(mesg,stmt)	_StartWatch() ; 	\
								stmt ;				\
								_StopWatch(mesg) ;
#endif
#else
	#define _StartWatch()
	#define _StopWatch(mesg)
 	#define _Timer(mesg,stmt)	stmt
#endif	// USE_STOPWATCH


#endif // _stopwatch_h
