#ifdef _MSC_VER
#pragma warning ( push )
#pragma warning ( disable:4005 ) // '_WIN32_WINNT' : macro redefinition
#define _WIN32_WINNT 0x0500
#pragma warning ( pop )
#endif




#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__


#ifndef __vl_autoreg_h__
#define __vl_autoreg_h__

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/* Forward Declarations */ 

/* header files for imported files */
#include "vl_ipl.h"
#include "vl_pat.h"

#ifdef __cplusplus
extern "C"{
#endif 

void * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void * ); 

/* interface __MIDL_itf_vl_autoreg_0000 */
/* [local] */ 

//=--------------------------------------------------------------------------=
// (C) Copyright 2002-2010 MATRIX VISION GmbH.  All Rights Reserved.
// (C) Copyright 1997-2010 Impuls computergesttzte Bildanalyse GmbH.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//=--------------------------------------------------------------------------=

#if defined(__BORLANDC__)
#pragma option -b
#endif
#if !defined(NO_VL_AUTOREG_AUTOLINK)
#if defined(__BORLANDC__)
#pragma comment(lib,"vlb_autoreg.lib")
#pragma message ("Automatically linking with vlb_autoreg.lib")
#else
#if defined(_M_X64)
#if _MSC_VER >= 1500
#pragma comment(lib,"vl_autoreg.lib")
#pragma message ("Automatically linking with vl_autoreg.lib")
#else
#pragma comment(lib,"vl_autoreg64.lib")
#pragma message ("Automatically linking with vl_autoreg64.lib")
#endif
#else
#pragma comment(lib,"vl_autoreg.lib")
#pragma message ("Automatically linking with vl_autoreg.lib")
#endif
#endif
#endif


#ifdef MVIMPACT_H_ // include guard of the main C++ header
namespace mvIMPACT {
	namespace mvIMPACT_C {
#endif // #ifdef MVIMPACT_H_


// Calling method for C Functions and C++ global and class methods.
// With other words: everything without a this-pointer
#define IPL_C_CALLTYPE __stdcall
#define IPL_C_CALLTYPEVAR __cdecl

// Calling method for the C++ methods with a this pointer.
// C++ static methods or C++ functions use IPL_C_CALLTYPE[VAR]
#define IPL_CPP_CALLTYPE // nothing == 'C++-call'
#define IPL_CPP_CALLTYPEVAR __cdecl

#ifdef VL_AUTOREG_COMPILING
// when compiling the dll
#define VL_AUTOREG_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllexport)
#else
// when using the dll
#define VL_AUTOREG_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllimport)
#endif


extern RPC_IF_HANDLE __MIDL_itf_vl_autoreg_0000_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_autoreg_0000_v0_0_s_ifspec;


#ifndef __vl_autoreg_LIBRARY_DEFINED__
#define __vl_autoreg_LIBRARY_DEFINED__

/* library vl_autoreg */
/* [helpstring][version][uuid] */ 

/* [helpstring] */ 
enum AR_ERROR
    {	AR_E_HANDLE_INVALID	= -300,
	AR_E_NOBESTMODEL	= -301,
	AR_E_BORDER_INVALID	= -302,
	AR_E_MODELSIZE_INVALID	= -303,
	AR_E_SCORE_INVALID	= -304,
	AR_E_LMODE_INVALID	= -305,
	AR_E_MODELPOS_INVALID	= -306,
	AR_E_MODEL_NOT_FOUND	= -307,
	AR_E_NOT_ENOUGH_MATCHES	= -308,
	AR_E_TILES_INVALID	= -309,
	AR_E_MODELCOUNT_INVALID	= -310
    } ;
typedef /* [hidden] */ enum AR_ERROR AR_ERROR;

/* [helpstring] */ 
enum AR_REGISTER_MODE
    {	AR_NEARESTNEIGHBOR	= 0,
	AR_BILINEAR	= 0x1,
	AR_CLEAR	= 0,
	AR_INTERPOLATE	= 0x2,
	AR_DEFAULT	= 0,
	AR_BANDS	= 0x4,
	AR_SLICES	= 0x8,
	AR_FRAMES	= 0x10
    } ;
typedef /* [hidden] */ enum AR_REGISTER_MODE AR_REGISTER_MODE;

/* [helpstring] */ 
enum AR_MODEL_COUNT
    {	AR_ONE_MODEL	= 0,
	AR_THREE_MODELS	= 0x2
    } ;
typedef /* [hidden] */ enum AR_MODEL_COUNT AR_MODEL_COUNT;


EXTERN_C const IID LIBID_vl_autoreg;


#ifndef __vl_autoreg_MODULE_DEFINED__
#define __vl_autoreg_MODULE_DEFINED__


/* module vl_autoreg */
/* [dllname][uuid] */ 

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall AR_SearchModel( 
    /* [in] */ IPL_BUFHANDLE Reference,
    /* [in] */ IPL_BUFHANDLE Match,
    /* [in] */ const IPL_RECT *ModelArea,
    /* [in] */ IPL_DOUBLE HCenter,
    /* [in] */ IPL_DOUBLE VCenter,
    /* [in] */ IPL_DOUBLE MinScore,
    /* [size_is][out] */ IPL_DOUBLE *Score,
    /* [size_is][out] */ IPL_DOUBLE *HFound,
    /* [size_is][out] */ IPL_DOUBLE *VFound);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall AR_MatchPair( 
    /* [in] */ IPL_BUFHANDLE Reference,
    /* [in] */ IPL_BUFHANDLE Match,
    /* [in] */ IPL_ULONG LeftBorder,
    /* [in] */ IPL_ULONG TopBorder,
    /* [in] */ IPL_ULONG RightBorder,
    /* [in] */ IPL_ULONG BottomBorder,
    /* [in] */ IPL_ULONG XTiles,
    /* [in] */ IPL_ULONG YTiles,
    /* [in] */ AR_MODEL_COUNT Models,
    /* [in] */ IPL_ULONG Width,
    /* [in] */ IPL_ULONG Height,
    /* [in] */ IPL_DOUBLE MinScore,
    /* [size_is][out] */ IPL_DOUBLE *Matrix);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall AR_RegisterPair( 
    /* [in] */ IPL_BUFHANDLE Reference,
    /* [in] */ IPL_BUFHANDLE Match,
    /* [full][out][in] */ IPL_BUFHANDLE *Destination,
    /* [in] */ IPL_ULONG LeftBorder,
    /* [in] */ IPL_ULONG TopBorder,
    /* [in] */ IPL_ULONG RightBorder,
    /* [in] */ IPL_ULONG BottomBorder,
    /* [in] */ IPL_ULONG XTiles,
    /* [in] */ IPL_ULONG YTiles,
    /* [in] */ AR_MODEL_COUNT Models,
    /* [in] */ IPL_ULONG Width,
    /* [in] */ IPL_ULONG Height,
    /* [in] */ IPL_DOUBLE MinScore,
    /* [in] */ AR_REGISTER_MODE Mode);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall AR_RegisterSequence( 
    /* [in] */ IPL_BUFHANDLE Match,
    /* [full][out][in] */ IPL_BUFHANDLE *Destination,
    /* [in] */ IPL_ULONG LeftBorder,
    /* [in] */ IPL_ULONG TopBorder,
    /* [in] */ IPL_ULONG RightBorder,
    /* [in] */ IPL_ULONG BottomBorder,
    /* [in] */ IPL_ULONG XTiles,
    /* [in] */ IPL_ULONG YTiles,
    /* [in] */ AR_MODEL_COUNT Models,
    /* [in] */ IPL_ULONG Width,
    /* [in] */ IPL_ULONG Height,
    /* [in] */ IPL_DOUBLE MinScore,
    /* [in] */ AR_REGISTER_MODE Mode);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall AR_CheckLic( void);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall AR_GetVersion( 
    /* [full][in] */ const IPL_CHAR *Buffer,
    /* [in] */ IPL_INT Bytes);

#endif /* __vl_autoreg_MODULE_DEFINED__ */
#endif /* __vl_autoreg_LIBRARY_DEFINED__ */

/* interface __MIDL_itf_vl_autoreg_0124 */
/* [local] */ 


#ifdef MVIMPACT_H_ // include guard of the main C++ header
	} // namespace mvIMPACT_C
} // namespace mvIMPACT
#endif // #ifdef MVIMPACT_H_



extern RPC_IF_HANDLE __MIDL_itf_vl_autoreg_0124_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_autoreg_0124_v0_0_s_ifspec;

/* Additional Prototypes for ALL interfaces */

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


