#ifdef _MSC_VER
#pragma warning ( push )
#pragma warning ( disable:4005 ) // '_WIN32_WINNT' : macro redefinition
#define _WIN32_WINNT 0x0500
#pragma warning ( pop )
#endif




#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__


#ifndef __vl_blobloc_h__
#define __vl_blobloc_h__

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/* Forward Declarations */ 

/* header files for imported files */
#include "vl_base.h"

#ifdef __cplusplus
extern "C"{
#endif 

void * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void * ); 

/* interface __MIDL_itf_vl_blobloc_0000 */
/* [local] */ 

//=--------------------------------------------------------------------------=
// (C) Copyright 2002-2010 MATRIX VISION GmbH.  All Rights Reserved.
// (C) Copyright 1997-2010 Impuls computergesttzte Bildanalyse GmbH.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//=--------------------------------------------------------------------------=

#if defined(__BORLANDC__)
#pragma option -b
#endif
#if !defined(NO_VL_BLOBLOC_AUTOLINK)
#if defined(__BORLANDC__)
#pragma comment(lib,"vlb_blobloc.lib")
#pragma message ("Automatically linking with vlb_blobloc.lib")
#else
#if defined(_M_X64)
#if _MSC_VER >= 1500
#pragma comment(lib,"vl_blobloc.lib")
#pragma message ("Automatically linking with vl_blobloc.lib")
#else
#pragma comment(lib,"vl_blobloc64.lib")
#pragma message ("Automatically linking with vl_blobloc64.lib")
#endif
#else
#pragma comment(lib,"vl_blobloc.lib")
#pragma message ("Automatically linking with vl_blobloc.lib")
#endif
#endif
#endif


#ifdef MVIMPACT_H_ // include guard of the main C++ header
namespace mvIMPACT {
	namespace mvIMPACT_C {
#endif // #ifdef MVIMPACT_H_

#ifdef VL_BLOBLOC_COMPILING
// when compiling the dll
#define VL_BLOBLOC_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllexport)
#else
// when using the dll
#define VL_BLOBLOC_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllimport)
#endif


extern RPC_IF_HANDLE __MIDL_itf_vl_blobloc_0000_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_blobloc_0000_v0_0_s_ifspec;


#ifndef __vl_blobloc_LIBRARY_DEFINED__
#define __vl_blobloc_LIBRARY_DEFINED__

/* library vl_blobloc */
/* [helpstring][version][uuid] */ 

typedef /* [helpstring] */ _BLOC_BUFHANDLE BLOC_BUFHANDLE;

typedef /* [helpstring] */ _BLOC_HANDLE BLOC_HANDLE;


enum BLOC_ERROR
    {	BLOC_INVALID_PARAMETER_ERROR	= -4200,
	BLOC_INVALID_CONTROL_VALUE	= -4201,
	BLOC_HANDLE_ERROR	= -4202,
	BLOC_STOPPED_AFTER_INDEX	= -4203
    } ;
typedef /* [hidden] */ enum BLOC_ERROR BLOC_ERROR;


enum BLOC_CONTROL
    {	BLOC_CTLID_LATTICE_MODE	= 1,
	BLOC_CTLID_STOP_AFTER_INDEX	= 2,
	BLOC_CTLID_KILL_BORDER_OBJECTS	= 3,
	BLOC_CTLID_MIN_SIZE	= 4,
	BLOC_CTLID_MAX_SIZE	= 5,
	BLOC_CTLID_CAMCAL_HANDLE	= 6,
	BLOC_CTLID_THRESHOLD	= 7,
	BLOC_CTLID_OBJECTSTATE	= 8,
	BLOC_CTLID_REMOVE_FILTERED_OBJECTS	= 9,
	BLOC_CTLID_OUTLINE	= 10
    } ;
typedef /* [hidden] */ enum BLOC_CONTROL BLOC_CONTROL;


enum BLOC_RESULTS
    {	BLOC_BOUNDING_BOX	= 1,
	BLOC_AREA	= 2,
	BLOC_NB_OUTLINE_POINTS	= 3,
	BLOC_OUTLINE_POINTS	= 4,
	BLOC_NB_SCANLINES	= 5,
	BLOC_SCANLINES	= 6
    } ;
typedef /* [hidden] */ enum BLOC_RESULTS BLOC_RESULTS;


EXTERN_C const IID LIBID_vl_blobloc;


#ifndef __vl_blobloc_MODULE_DEFINED__
#define __vl_blobloc_MODULE_DEFINED__


/* module vl_blobloc */
/* [dllname][uuid] */ 

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BLOC_SetProcMode( 
    /* [in] */ BLOC_CONTROL Item,
    /* [in] */ IPL_LONG Value);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BLOC_GetProcMode( 
    /* [in] */ BLOC_CONTROL Item,
    /* [in] */ IPL_LONG *Value);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BLOC_LocateObjects( 
    IPL_BUFHANDLE BufHandleBin,
    IPL_BUFHANDLE BufHandleGray,
    IPL_BUFHANDLE *BufHandleDest,
    BLOC_BUFHANDLE *ResultPtr);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BLOC_BufFree( 
    BLOC_BUFHANDLE ResultPtr);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BLOC_InquirePlanes( 
    BLOC_BUFHANDLE ResultPtr,
    IPL_LONG *BandPtr,
    IPL_LONG *SlicePtr,
    IPL_LONG *FramePtr);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BLOC_InquireObjects( 
    BLOC_BUFHANDLE ResultPtr,
    IPL_LONG Band,
    IPL_LONG Slice,
    IPL_LONG Frame,
    IPL_LONG *ObjectsPtr);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BLOC_GetResultBufData( 
    BLOC_BUFHANDLE ResultPtr,
    IPL_LONG Band,
    IPL_LONG Slice,
    IPL_LONG Frame,
    IPL_LONG Index,
    BLOC_RESULTS Feature,
    IPL_VOID_PTR Ptr);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BLOC_GetResultHandle( 
    BLOC_BUFHANDLE ResultPtr,
    IPL_LONG Band,
    IPL_LONG Slice,
    IPL_LONG Frame,
    IPL_LONG Index,
    BLOC_HANDLE *Handle);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BLOC_LocateSingleObject( 
    IPL_LONG XPos,
    IPL_LONG YPos,
    IPL_BUFHANDLE BufHandle,
    BLOC_BUFHANDLE *ObjectPtr);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BLOC_CheckLic( void);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BLOC_GetVersion( 
    /* [full][in] */ const IPL_CHAR *Buffer,
    /* [in] */ IPL_INT Bytes);

#endif /* __vl_blobloc_MODULE_DEFINED__ */
#endif /* __vl_blobloc_LIBRARY_DEFINED__ */

/* interface __MIDL_itf_vl_blobloc_0119 */
/* [local] */ 


#ifdef MVIMPACT_H_ // include guard of the main C++ header
	} // namespace mvIMPACT_C
} // namespace mvIMPACT
#endif // #ifdef MVIMPACT_H_



extern RPC_IF_HANDLE __MIDL_itf_vl_blobloc_0119_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_blobloc_0119_v0_0_s_ifspec;

/* Additional Prototypes for ALL interfaces */

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


