REM 
REM This batch file is an example to show how patching licenses works.
REM 
REM 1.) You create a key pair for your license using cgenlic.
REM 2.) You take one of the qualifying LADs and patch it using this new key pair.
REM 3.) You create licenses files using the patched LAD and cgenlic.
REM 4.) You apply the license and test it.
REM 
REM The dummylib sample has been designed to help you.
REM 
REM It is important to understand that this batch file will *NOT* work out of the box,
REM since the pathes to the license files need to be adjusted. Also, most likely you 
REM do not have both a dongle and a board, so some of the calls will not work even
REM if the pathes have been adjusted properly.
REM 

REM change to the path to your private key file, i.e. "C:\my_private_key.key"
SET privatekey=...

REM change to the path to your public key file, i.e. C:\my_public_key.key"
SET publickey=...

REM change to your dongle serial number, i.e. "106-220424"
SET dongleserial=...

REM change to your framegrabber serial number, i.e. "GL037424022"
SET grabberserial=...

REM Change the pathes below

cpatchlic -d"C:\impact\bin\lic_dongle_all.dll" -r"Software\Impuls\AllDongles\LicenceKeys" -l"C:\impact\bin\lic_dongle_all_patched.dll" -n"Software\Impuls\AllDonglesPatched\LicenceKeys" -k%privatekey%
cpatchlic -d"C:\impact\bin\lic_dongle.dll" -r"Software\Impuls\Dongle\LicenceKeys" -l"C:\impact\bin\lic_dongle_patched.dll" -n"Software\Impuls\DonglePatched\LicenceKeys" -k%privatekey%
cpatchlic -d"C:\impact\bin\lic_matrix_all.dll" -r"Software\MATRIX Vision\AllGrabbers\LicenceKeys" -l"C:\impact\bin\lic_matrix_all_patched.dll" -n"Software\MATRIX Vision\AllGrabbersPatched\LicenceKeys" -k%privatekey%
cpatchlic -d"C:\impact\bin\lic_matrix.dll" -r"Software\MATRIX Vision\LicenceKeys" -l"C:\impact\bin\lic_matrix_patched.dll" -n"Software\MATRIX Vision\Patched\LicenceKeys" -k%privatekey%


REM Generating Licenses

cgenlic -l -mvl_dummy -s%dongleserial% -alic_dongle_patched -p%publickey% -v%privatekey% -x"patched_dummy_1.reg"
cgenlic -l -mvl_dummy -s"123-456789" -alic_dongle_all_patched -p%publickey% -v%privatekey% -x"patched_dummy_2.reg"
cgenlic -l -mvl_dummy -s"123-456789" -alic_matrix_all_patched -p%publickey% -v%privatekey% -x"patched_dummy_3.reg"
cgenlic -l -mvl_dummy -s%grabberserial% -alic_matrix_patched -p%publickey% -v%privatekey% -x"patched_dummy_4.reg"


REM Registrating licenses and cleanup

copy patched_dummy_1.reg + patched_dummy_2.reg + patched_dummy_3.reg + patched_dummy_4.reg patched_dummy.reg
del patched_dummy_1.reg
del patched_dummy_2.reg
del patched_dummy_3.reg
del patched_dummy_4.reg

regedit -s patched_dummy.reg

del patched_dummy.reg