#include <vl_base.h>
#include <vl_file.h>
#include <vl_ipl.h>
#include <vl_display.h>
#include <samples.h>

int main(int /*argc*/, char** /*argv[]*/)
{
    IPL_BUFHANDLE Image = -1;

	// import an image
	CHECKSDKCALL(IPL_FlImport(&Image, NULL, FL_DONT_CARE, "phone.bmp"));

	// open a window for the original image
    IPL_HWND Window1 = 0;
	CHECKSDKCALL(DISP_OpenWindow(Image, &Window1, 0, 0));

	// setup the multi-threshold palette
	IPL_THRESHOLD thresholds[] =
	{
		{ 50, IPL_LESS },
		{ 180, IPL_GREATER }
	};

	IPL_BUFHANDLE Palette = -1;
	CHECKSDKCALL(IPL_ThresholdPalette(thresholds, sizeof(thresholds)/sizeof(thresholds[0]), &Palette, IPL_DTUCHAR));

	// threshold
	IPL_BUFHANDLE Result = IPL_DONT_CARE;
	CHECKSDKCALL(IPL_PtLutMap(Image, IPL_DONT_CARE, &Result, Palette));

	// shuffle bitplanes 0 and 1 to 6 and 7 to make result visible
	IPL_SHUFFLE shuffle[] =
	{
		{ 0, 6 },
		{ 1, 7 }
	};

	IPL_BUFHANDLE Shuffle = -1;
	CHECKSDKCALL(IPL_ShuffleBitplanePalette(shuffle, sizeof(shuffle)/sizeof(shuffle[0]), &Shuffle));

	// threshold
	CHECKSDKCALL(IPL_PtLutMap(Result, IPL_DONT_CARE, &Result, Shuffle));


	IPL_HWND Window2 = 0;
	CHECKSDKCALL(DISP_OpenWindow(Result, &Window2, 0, 0));

	// keep sample alive until console window is closed or space bar is pressed
	CHECKSDKCALL(DISP_KeepRunning("Click the space bar to end program.\n"));

	IPL_BufFreeAll();

	return 0;
}

