#include <vl_base.h>
#include <vl_device.h>
#include <vl_display.h>
#include <samples.h>

int main(int /*argc*/, char** /*argv[]*/)
{
	// open device
	DEV_HANDLE device = IPL_DONT_CARE;
	CHECKSDKCALL(DEV_Open(&device, "matrixvision.ddc"));

    // make a snapshot
	IPL_BUFHANDLE image = IPL_DONT_CARE;
    CHECKSDKCALL(DEV_Control(device, DEV_SINGLE, 0));
    CHECKSDKCALL(DEV_Grab(device, &image));

	// open window to display image, with associated lut
	IPL_HWND hwnd = 0;
	CHECKSDKCALL(DISP_OpenWindow(image, &hwnd, 0, NULL));

	// keep sample alive until console window is closed or space bar is pressed
	CHECKSDKCALL(DISP_KeepRunning("Click the space bar to end program.\n"));
    
	// close device
    CHECKSDKCALL(DEV_Close(device));

	// free allocated buffers
	CHECKSDKCALL(IPL_BufFreeAll());

	return 0;
}
