// Unwind.cpp : Defines the entry point for the console application.
//

#include <vl_base.h>
#include <vl_file.h>
#include <vl_ipl.h>
#include <vl_display.h>
#include <samples.h>

int main(int /*argc*/, char** /*argv[]*/)
{
	IPL_BUFHANDLE lhBuf = IPL_DONT_CARE;
	IPL_BUFHANDLE lhBufUnwind = IPL_DONT_CARE;

	// Load sample file
	CHECKSDKCALL(IPL_FlImport(&lhBuf, NULL, FL_DONT_CARE, "unwind.bmp"));

	// Unwind the image
	CHECKSDKCALL(IPL_TrUnwind(
        lhBuf,			// source buffer
        &lhBufUnwind,	// destination buffer
        400,			// XExtent
        400,			// YExtent
        312.,			// x-center of polar transformation
        234.,			// y-center of polar transformation
        270.,			// start from angle
        135.,			// up to angle
		195,			// start position where to start unwinding
		70,				// end position where to stop unwinding
        0.4,			// Anglestep
        0.,				// RotationAngle
        IPL_BILINEAR));	// interpolation mode

	// Open Window and draw image
	IPL_HWND hWnd = 0;
	CHECKSDKCALL( DISP_OpenWindow( lhBuf, &hWnd, 0, NULL ));
	CHECKSDKCALL(DISP_KeepRunning("Press space bar to continue.\n"));

	hWnd = 0;
	CHECKSDKCALL( DISP_OpenWindow( lhBufUnwind, &hWnd, 0, NULL ));
	CHECKSDKCALL( DISP_KeepRunning("Press space bar to end the programm.\n"));

	//free buffers
	CHECKSDKCALL(IPL_BufFree(lhBuf));
	CHECKSDKCALL(IPL_BufFree(lhBufUnwind));

	return 0;
}

