//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

#include <vl_base.h>
#include <vl_ipl.h>
#include <vl_device.h>
#include <vl_display.h>

#include <samples.h>

//---------------------------------------------------------------------------
int main( int /*argc*/, char * /*argv[]*/ )
{
	DEV_HANDLE device = IPL_DONT_CARE;
	if( !DEV_Open( &device, "matrixvision.ddc" ))
	{
		fprintf( stderr, "*** open device failed (err: %ld)\n", IPL_GetErrorCode( ));
		return -1;
	}

    if( !DEV_Control( device, DEV_SINGLE, 0 ))
	{
		fprintf( stderr, "*** device control failed (err: %ld)\n", IPL_GetErrorCode( ));
		return -1;
	}

	IPL_HWND hwnd = 0;
	IPL_BUFHANDLE image = IPL_DONT_CARE;
	if( !DEV_Grab( device, &image ))
	{
		fprintf( stderr, "*** grab image failed (err: %ld)\n", IPL_GetErrorCode( ));
		return -1;
	}

	if( !DISP_OpenWindow( image, &hwnd, 0, NULL ))
	{
		fprintf( stderr, "*** open window failed (err: %ld)\n", IPL_GetErrorCode( ));
		return -1;
	}

	DISP_UpdateWindow( hwnd, DISP_INVALIDATE );

	printf(" Press <ENTER> to stop the demo!!\n");

	while( !_kbhit( ))
	{
		if( !DEV_Grab( device, &image ))
		{
			fprintf( stderr, "*** grab image failed (err: %ld)\n", IPL_GetErrorCode( ));
			return -1;
		}

		IPL_Convolve( image, &image, IPL_SOBEL );
		DISP_UpdateWindow( hwnd, DISP_INVALIDATE );
		DISP_KeepRunning( NULL );
	}

    DEV_Close( device );
	IPL_BufFree( image );

	return 0;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
