//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - mvBlueLYNX demo >>blob-afs<<
// Mit Aug 13 11:31:13 CEST 2003
//----------------------------------------------------------------------
#ifndef __blob_afs_h__
#define __blob_afs_h__

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#include <stdio.h>

#include <vl_base.h>
#include <vl_device.h>
#include <vl_display.h>

#include <pgutils.h>
#include <samples.h>

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#define TOOL_PREFIX								"blob-afs"
#define INIT_FILE								"blob-afs.ini"
#define BIN_FILE								"blob-afs.bin"

#define KB_ERROR								"KEYBOARD ERROR"
#define SIMG_ERROR								"SAVE IMAGE ERROR"
#define SAVE_ERROR								"SAVE ERROR"
#define NOTE_STR								"NOTE..."
#define AN_ERROR								"ERROR!!"

#define FREAD									"r"
#define FWRITE									"w"

#define MAX_CHAR_SIZE							256
#define MAX_BUF_SIZE							80
#define MAX_CLASS_NB							( 10 + 1 )

#define MVCOLOR_WHITE							PALETTERGB( 255, 255, 255 )
#define MVCOLOR_GREY							PALETTERGB( 127, 127, 127 )
#define MVCOLOR_BLACK							PALETTERGB( 0, 0, 0 )
#define MVCOLOR_RED								PALETTERGB( 255, 0, 0 )
#define MVCOLOR_GREEN							PALETTERGB( 0, 255, 0 )
#define MVCOLOR_BLUE							PALETTERGB( 0, 0, 255 )
#define MVCOLOR_YELLOW							PALETTERGB( 255, 255, 0 )
#define MVCOLOR_MAGENTA							PALETTERGB( 255, 0, 255 )
#define MVCOLOR_L_BLUE							PALETTERGB( 0, 255, 255 )

#define RET_SUCCESS								0
#define RET_ERROR								-1
#define RET_CLOSE								-2
#define RET_SKIPP								-3

#define TEACH_GUI								0
#define DELETE_GUI								1

//----------------------------------------------------------------------
#define CHECK_RET( f )										\
	if( !( f ))	{ fprintf( stderr, "*** %s (%s: %d) - err: %ld form " #f " == %s\n",	\
					__FUNCTION__, __FILE__, __LINE__, IPL_GetErrorCode2( ),				\
					IPL_GetErrorString(IPL_GetErrorCode2())); }

#ifdef LINE_DEBUG
	#ifdef DEBUG
		#undef DEBUG
	#endif

	#define __stmt( stmt )													\
			do { stmt; printf(" --> %s line %d\n", __FILE__, __LINE__ ); }	\
			while( 0 )

	#define DPRINTF( p )	__stmt( printf p; )
#elif DEBUG
	#define DPRINTF( p )	dprintf( p ); printf("\n")
#else
	#define DPRINTF( p )
#endif //LINE_DEBUG


#ifdef MEM_DEBUG
	#define allocprintf( b, pos )	a##pos##printf( b )

	#define aiprintf( b )		\
		printf(" => %s (%d): malloc %p\n", __FILE__, __LINE__, b );

	#define aoprintf( b )		\
		printf(" <= %s (%d): malloc %p\n", __FILE__, __LINE__, b );

	#define freeprintf( b, pos )	f##pos##printf( b )

	#define fiprintf( b )		\
		printf(" => %s (%d): free %p\n", __FILE__, __LINE__, b );

	#define foprintf( b )		\
		printf(" <= %s (%d): free %p\n", __FILE__, __LINE__, b );

#else
	#define allocprintf( b, pos );
	#define freeprintf( b, pos );
#endif

#define ddprintf( f )		printf(" !?! %s called from %s in %s at %d\n", f, __FUNCTION__, __FILE__, __LINE__ );

//----------------------------------------------------------------------
//----------------------------------------------------------------------
extern unsigned int run_flag;

//----------------------------------------------------------------------
void close_all( );
void snap_img( );
int mk_bin_img( IPL_BUFHANDLE src, IPL_BUFHANDLE *dst, int polarity );

void run_analyse( unsigned int flag );
void single_snap( );
void displ_binimg( unsigned int flag );

int get_blob_pos( IPL_RECT *rect, unsigned int *ilist );
void display_all( );
void get_child_img( BYTE *child_buf, unsigned long x, unsigned long y, unsigned long w, unsigned long h );

int calc_res( );
int get_bin_img( );

void *clear_buf( void *buf );
void clear_img( IPL_BUFHANDLE *img );

int get_polarity( );
void set_polarity( unsigned int val );
long get_err_code( );
long get_threshold( );
void use_auto_threshold( unsigned int flag );
void set_threshold( unsigned long val );
unsigned int get_threshold_mode( );

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#endif	// __blob-afs_h__
