//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - mvBlueLYNX demo >>blob-afs<<
// Tue May 20 14:35:47 CEST 2003
//----------------------------------------------------------------------
//----------------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <picogui.h>
#include <system.h>
#include <pgutils.h>

#include "blob-afs.h"
#include "afsapi.h"
#include "blbproc.h"

//-------------------------------------------------------------------
//-------------------------------------------------------------------
static pghandle wDisplay, wSegDisplay;

//-------------------------------------------------------------------
//int get_class_name( BYTE *img_buffer, int width, int height, char class_list[MAX_CLASS_NB][MAX_BUF_SIZE], int *list_size )
int get_class_name( BYTE *img_buffer, int width, int height, char *class_name,
					char class_list[MAX_CLASS_NB][MAX_BUF_SIZE], int list_size, int gui_type )
{
	dprintf((" -> " TOOL_PREFIX ": get_class_name\n"));

	BYTE *image = NULL;
	char iheader[MAX_CHAR_SIZE], msg[MAX_BUF_SIZE], name[MAX_BUF_SIZE], *pmsg = NULL;
	memset( iheader, 0, MAX_CHAR_SIZE );
	memset( msg, 0, MAX_BUF_SIZE );
	memset( name, 0, MAX_BUF_SIZE );
	int len = sprintf( iheader, "P5\n# ipl Gray test header\n%d %d\n255\n", width, height );

	pgEnterContext( );
	pghandle wApply, wClose, wToolbar, wPopup, wSkipp = 0;
	pghandle wBox, wDispBox, wBox2=0, *wItem = NULL, wIBox = 0;
	struct pgEvent *evt;

	if( gui_type == TEACH_GUI )
		sprintf( name, "Blob-AFS Teach mode" );
	else
		sprintf( name, "Blob-AFS Delete mode" );

	wPopup = pgRegisterApp( PG_APP_TOOLBAR, name, 0 );

	pgNewWidget( PG_WIDGET_BOX, 0, 0 );
	pgNewWidget( PG_WIDGET_LABEL, PG_DERIVE_INSIDE, PGDEFAULT );
	pgSetWidget( PGDEFAULT,
			PG_WP_TEXT, pgNewString( name ),
			PG_WP_FONT, pgNewFont( NULL, 14, 0 ),
			0 );

	wToolbar = pgNewWidget( PG_WIDGET_TOOLBAR, 0, 0 );
	pgSetWidget( PGDEFAULT,
			PG_WP_SIDE, PG_S_BOTTOM,
			PG_WP_PUBLICBOX, 1,
			0 );

	wApply = pgNewWidget( PG_WIDGET_BUTTON, PG_DERIVE_INSIDE, wToolbar );
	pgSetWidget( PGDEFAULT,
			PG_WP_TEXT, pgNewString( "Apply" ),
			0 );

	if( gui_type == TEACH_GUI )
	{
		wSkipp = pgNewWidget( PG_WIDGET_BUTTON, 0, 0 );
		pgSetWidget( PGDEFAULT,
				PG_WP_TEXT, pgNewString( "Skip" ),
				0 );
	}

	wClose = pgNewWidget( PG_WIDGET_BUTTON, 0, 0 );
	pgSetWidget( PGDEFAULT,
			PG_WP_TEXT, pgNewString("Close"),
			0 );

	sprintf( msg, "NEW_CLASS_01" );
	wDispBox = pgNewWidget( PG_WIDGET_BOX, PG_DERIVE_AFTER, wToolbar );
	wDisplay = pgNewWidget( PG_WIDGET_TEXTBOX, PG_DERIVE_INSIDE, wDispBox );
	pgSetWidget( PGDEFAULT,
			PG_WP_TEXT, pgNewString( msg ),
			PG_WP_SIDE, PG_S_ALL,
			0 );

	pgFocus( wDisplay );
	
	dprintf((" == " TOOL_PREFIX ": get_class_name - list_size: %d\n", list_size ));
	if( list_size > 0 )
	{
		allocprintf( wItem, i );
		if(( wItem = (pghandle*)malloc( list_size * sizeof(pghandle))) != NULL )
		{
			allocprintf( wItem, o );
			memset(wItem, 0, list_size * sizeof(pghandle));

			wBox2 = pgNewWidget( PG_WIDGET_BOX, PG_DERIVE_AFTER, wDispBox  );
			pgSetWidget( PGDEFAULT, PG_WP_SIDE, PG_S_TOP, 0 );

			for( int c = 0; c < list_size; c += 3 )
			{
				wIBox = pgNewWidget( PG_WIDGET_BOX,
								c ? PG_DERIVE_AFTER : PG_DERIVE_INSIDE,
								c ? wIBox : wBox2 );

				pgSetWidget( PGDEFAULT,
						PG_WP_SIDE, PG_S_LEFT,
						0 );

				for( int i = 0; i < 3; i++ )
				{
					if( c + i >= list_size )
						break;

					dprintf((" == " TOOL_PREFIX ": get_class_name - i: %d, cl: >%s<\n", i, class_list[i] ));
					wItem[c + i] = pgNewWidget( PG_WIDGET_LISTITEM,
							i ? PGDEFAULT : PG_DERIVE_INSIDE,
							i ? PGDEFAULT : wIBox );

					pgSetWidget( PGDEFAULT,
							PG_WP_FONT, pgNewFont( NULL, 8, 0 ),
							PG_WP_TEXT, pgNewString( class_list[c + i] ),
							0 );
					//pgReplaceText( PGDEFAULT, class_list[i] );
				}
			}
		}
	}

	if( wBox2 != 0 )
		wBox = pgNewWidget( PG_WIDGET_BOX, PG_DERIVE_AFTER, wBox2 );
	else
		wBox = pgNewWidget( PG_WIDGET_BOX, PG_DERIVE_AFTER, wDispBox );
	pgSetWidget( PGDEFAULT,
			PG_WP_SIDE, PG_S_TOP,
			PG_WP_MARGIN, 0,
			0 );

	if( img_buffer )
	{
		allocprintf( image, i );
		if(( image = (BYTE*) malloc( len + width * height )) != NULL )
		{
			allocprintf( image, o );
			char str[MAX_BUF_SIZE];
			memset( str, 0, MAX_BUF_SIZE );
			sprintf( str, "Found blob!\nPlease enter the class name before\nstarting the teach operation!!\n" );
			memcpy( image + 0, iheader, len );
			memcpy( image + len, img_buffer, width * height );

			int ih = 80;
			if( height > ih )
				ih = height;

			wSegDisplay = pgNewWidget( PG_WIDGET_LABEL, PG_DERIVE_INSIDE, wBox );
			pgSetWidget( PGDEFAULT,
					PG_WP_SIDE, PG_S_TOP,
					PG_WP_SIZE, ih,
					PG_WP_BITMAP, pgNewBitmap( pgFromMemory( image, len + width * height )),
					PG_WP_TEXT, pgNewString( str ),
					0 );
		}
	}

	for (;;)
	{
		evt = pgGetEvent();
		dprintf((" == " TOOL_PREFIX ": get_class_name - evt %ld\n", evt->from ));
		if( wItem != NULL )
		{
			for( int i = 0; i < list_size; i++ )
			{
				if( evt->from == wItem[i] )
				{
					pghandle oldtext = pgGetWidget( wDisplay, PG_WP_TEXT );
					pgSetWidget( wDisplay,
								PG_WP_TEXT, pgGetWidget( wItem[i], PG_WP_TEXT ),
								0 );
					pgSubUpdate( wDisplay );
					pgSubUpdate( wDispBox );
					pgDelete( oldtext );
					break;
				}
			}
		}

		if( evt->from == wClose )
		{
			freeprintf( wItem, i );
				wItem = (pghandle *)clear_buf( wItem );
			freeprintf( wItem, o );

			freeprintf( image, i );
				image = (BYTE *)clear_buf( image );
			freeprintf( image, o );

			pgLeaveContext( );
			return RET_CLOSE;
		}
		else if( evt->from == wSkipp )
		{
			freeprintf( wItem, i );
				wItem = (pghandle *)clear_buf( wItem );
			freeprintf( wItem, o );

			freeprintf( image, i );
				image = (BYTE *)clear_buf( image );
			freeprintf( image, o );

			pgLeaveContext( );
			return RET_SKIPP;
		}
		else if( evt->from == wApply )
		{
			int ret = RET_ERROR;
			if(( pmsg = pgGetString( pgGetWidget( wDisplay, PG_WP_TEXT ))) != NULL )
			{
				dprintf((" == " TOOL_PREFIX ": get_class_name - pmsg: >%s<\n", pmsg ));
				int slen = strlen( pmsg ) - strlen("\n");
				dprintf((" == " TOOL_PREFIX ": get_class_name - slen: >%d<\n", slen ));
				memset( class_name, 0, slen + 1 );
				strncpy( class_name, pmsg, slen );
				dprintf((" == " TOOL_PREFIX ": get_class_name - class_name: >%s<\n", class_name ));
				ret = RET_SUCCESS;
			}

			freeprintf( wItem, i );
				wItem = (pghandle *)clear_buf( wItem );
			freeprintf( wItem, o );

			freeprintf( image, i );
				image = (BYTE *)clear_buf( image );
			freeprintf( image, o );

			pgLeaveContext( );
			return ret;
		}
	}

	freeprintf( wItem, i );
		wItem = (pghandle *)clear_buf( wItem );
	freeprintf( wItem, o );

	freeprintf( image, i );
		image = (BYTE *)clear_buf( image );
	freeprintf( image, o );

	pgLeaveContext( );
	return RET_ERROR;
}


//----------------------------------------------------------------------
//----------------------------------------------------------------------
