//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - mvBlueLYNX demo >>crtool<<
// Don Apr 29 14:28:38 CEST 2004
//----------------------------------------------------------------------
#ifndef __crtool_h__
#define __crtool_h__

//----------------------------------------------------------------------
#include <stdio.h>
#include <vl_base.h>
#include <vl_device.h>
#include <vl_display.h>

#include "pgtools.h"
#include "prop.h"

//----------------------------------------------------------------------
#define TOOL_PREFIX								"crtool"

#define NOT_AUTO_MODE_STR						"NOT AUTO DECODE"
#define AUTO_MODE_STR							"AUTO DECODE"

#define START_LIVE_STR							"live"
#define STOP_LIVE_STR							"stopped live"

#define NO_ONJ_SEL_STR							"NO OBJECT SELECTED"
#define PREFIX_4_MSG_DATA						"MSG_DATA"

#define KB_ERROR								"KEYBOARD ERROR"
#define SIMG_ERROR								"SAVE IMAGE ERROR"
#define SAVE_ERROR								"SAVE ERROR"
#define NOTE_STR								"NOTE..."
#define AN_ERROR								"ERROR!!"

#define NO_SRC_STR								"Empty source image buffer"
#define NO_POLARITY_STR							"No polarity selected (B/W or W/B)"

#define CPP_FILE_NAME							"mv_cr_decoder.cpp"
#define PGM_FILE_NAME							"img_crtool.pgm"
#define INI_FILE_NAME							"crtool.ini"

#define MVCOLOR_WHITE							PALETTERGB( 255, 255, 255 )
#define MVCOLOR_GREY							PALETTERGB( 127, 127, 127 )
#define MVCOLOR_BLACK							PALETTERGB( 0, 0, 0 )
#define MVCOLOR_RED								PALETTERGB( 255, 0, 0 )
#define MVCOLOR_GREEN							PALETTERGB( 0, 255, 0 )
#define MVCOLOR_BLUE							PALETTERGB( 0, 0, 255 )
#define MVCOLOR_YELLOW							PALETTERGB( 255, 255, 0 )
#define MVCOLOR_MAGENTA							PALETTERGB( 255, 0, 255 )
#define MVCOLOR_L_BLUE							PALETTERGB( 0, 255, 255 )

#define MAX_CHAR_SIZE							256
#define MSG_SIZE								80

#define DISPLAY_TEXT_Y_OFFSET					10

#define RET_SUCCESS								0
#define RET_ERROR								-1
#define RET_CLOSE								-2
#define RET_SKIPP								-3

#define DEC_TO_SEC								1
#define DEC_TO_USEC								0

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#define IPL_Call( f )	if( !f ) goto FAILURE

//----------------------------------------------------------------------
//----------------------------------------------------------------------
struct SSpinEdit
{
	pghandle wBox;
	SStatusInfo si;
	pghandle wBtnUp;
	pghandle wBtnDown;
	pghandle wLabel;
};
typedef struct SSpinEdit SPIN_EDIT;

//----------------------------------------------------------------------
//----------------------------------------------------------------------
extern int run_flag, se_mode;
extern pghandle wApp, wBox, wStatLine, wCTRL, wSave, wMainCanvas;

//----------------------------------------------------------------------
//----------------------------------------------------------------------
/** functions from crtool.cpp **/

void close_all( );
void snap_img( );

int set_disp_img_mode( const int image_mode );
int set_disp_result_mode( const int result_mode );
int set_obj2disp_index( const int index );

int  get_cr_index( const IPL_POINT click );
long get_dec_time( );
long get_preproc_time( );

int  get_cr1d_obj_cnt( );
void get_cr1d_data( const int index, char *data );
int  get_cr1d_quality( const int index );

int  get_cr2d_obj_cnt( );
void get_cr2d_data( const int index, char *data );
int  get_cr2d_quality( const int index );

int  get_threshold( );

void save_img( );
void set_decoder( const unsigned int flag );
void set_decoder_type( const unsigned int type );
int  set_dec_prop( const CR_PROPS_ID prop );
void set_cr_props( );

/** end functions from crtool.cpp **/

//int get_ival( );
void dummy_snap_and_cpy( );
void gen_src_file( const char *fname );

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#endif	// __crtool_h__
