//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - mvBlueLYNX demo >>dmtool<<
// Mon Jul  7 09:35:32 CEST 2003
//----------------------------------------------------------------------
#ifndef __preproc_h__
#define __preproc_h__

//----------------------------------------------------------------------
//----------------------------------------------------------------------
/******************/
/* Image cleaning */
/******************/
int img_clean_best( const IPL_BUFHANDLE sourceHandle, IPL_BUFHANDLE *destinationHandle, const int nStrength );
int img_clean_fast( const IPL_BUFHANDLE sourceHandle, IPL_BUFHANDLE *destinationHandle, const int nStrength );
int img_clean_salt_noise( const IPL_BUFHANDLE sourceHandle, IPL_BUFHANDLE *destinationHandle, const int nStrength );
int img_clean_pepper_noise( const IPL_BUFHANDLE sourceHandle, IPL_BUFHANDLE *destinationHandle, const int nStrength );

/********************/
/* Cell improvement */
/********************/
int cell_impr_2thin( const IPL_BUFHANDLE sourceHandle, IPL_BUFHANDLE *destinationHandle, const int nStrength, const int col_flag );
int cell_impr_2thick( const IPL_BUFHANDLE sourceHandle, IPL_BUFHANDLE *destinationHandle, const int nStrength, const int col_flag );
int cell_impr_nu( const IPL_BUFHANDLE sourceHandle, IPL_BUFHANDLE *destinationHandle, const int nStrength, const int col_flag );

/*******************/
/* Symbol location */
/*******************/
int symb_loc_sc_best( const IPL_BUFHANDLE sourceHandle, IPL_BUFHANDLE *destinationHandle, const int nStrength, const int col_flag );
int symb_loc_sc_fast( const IPL_BUFHANDLE sourceHandle, IPL_BUFHANDLE *destinationHandle, const int nStrength, const int col_flag );
int symb_loc_rs_best( const IPL_BUFHANDLE sourceHandle, IPL_BUFHANDLE *destinationHandle, const int nStrength, const int col_flag );
int symb_loc_rs_fast( const IPL_BUFHANDLE sourceHandle, IPL_BUFHANDLE *destinationHandle, const int nStrength, const int col_flag );

//----------------------------------------------------------------------
#endif	// __preproc_h__

//----------------------------------------------------------------------
//----------------------------------------------------------------------
