//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - mvBlueLYNX demo >>gmmtool<<
// Don Nov 13 11:40:07 CET 2003
//----------------------------------------------------------------------
#include <stdio.h>

#include "gmmtool.h"
#include "gmmipl.h"
#include "pgapi.h"
#include "pgdev.h"

//----------------------------------------------------------------------
//----------------------------------------------------------------------
static int process_flag = 0;

//----------------------------------------------------------------------
//----------------------------------------------------------------------
int load_gmm_file( )
{
	dprintf((" ++ " TOOL_PREFIX ": load_gmm_file\n" ));

	FILE *f = NULL;
	int ret = IPL_FALSE;

	if(( f = fopen( TOOL_PREFIX ".gmm", "r" )) != NULL )
	{
		fclose( f );

		ret = load_gmm_fl( );
	}

	dprintf((" -- " TOOL_PREFIX ": load_gmm_file (%d)\n", ret ));

	return ret;
}

//----------------------------------------------------------------------
#define GIV( istr, p_min, p_max, p_def )						\
			gmm_get_ival( INIT_STR_##istr, f, p_min, p_max, p_def )

#define INITFROMFILE( itype, istr, p_min, p_max )					\
		set_##itype( GIV( istr, p_min, p_max, get_##itype( )))

void init_from_file( )
{
	dprintf((" ++ " TOOL_PREFIX ": init_from_file\n" ));
	FILE *f = NULL;

	if(( f = fopen( TOOL_PREFIX ".ini", "r" )) != NULL )
	{
		process_flag = GIV( PROC, 0, 3, process_flag );
		INITFROMFILE( displ_res_mode, RDISP, GMM_DISPL_MATCH_TABLE, GMM_DISPL_TRIGS );
		INITFROMFILE( threshold, TH, 0, MAX_THRESHOLD );
		INITFROMFILE( quality, DISPQ, 0, MAX_QUALITY );
		INITFROMFILE( max_feat_nb, MAXFEAT, 0, MAX_FEAT_NB );
		INITFROMFILE( max_obj_nb, MAXOBJ, 0, MAX_OBJ_NB );

		fclose( f );
	}

	dprintf((" -- " TOOL_PREFIX ": init_from_file\n" ));
}

//----------------------------------------------------------------------
#define W2FL_I( a, b )							\
		fprintf( f, INIT_STR_##a "=%d\n", b );

#define W2FL_L( a, b )							\
		fprintf( f, INIT_STR_##a "=%ld\n", b );

int write2file( )
{
	dprintf((" ++ " TOOL_PREFIX ": write2file\n" ));

	int ret = -1;
	FILE *f = NULL;

	if(( f = fopen( TOOL_PREFIX ".ini", "w" )) != NULL )
	{
		fprintf( f, "## MATRIX VISION GmbH - " TOOL_PREFIX"\n" );
		fprintf( f, "## " __DATE__ " " __TIME__ "\n\n" );

		fprintf( f, "[GLOBALS]\n" );
		W2FL_I( PROC, process_flag );
		W2FL_I( RDISP, get_displ_res_mode( ));

		fprintf( f, "\n[GMM]\n" );
		W2FL_I( TH, get_threshold( ));
		W2FL_I( DISPQ, get_quality( ));
		W2FL_I( MAXFEAT, get_max_feat_nb( ));
		W2FL_I( MAXOBJ, get_max_obj_nb( ));

		fclose( f );
		ret = 0;
	}

	dprintf((" -- " TOOL_PREFIX ": write2file (%d)\n", ret ));
	return ret;
}

//----------------------------------------------------------------------
//----------------------------------------------------------------------
int main( int argc, char *argv[] )
{
	char msg[MSG_SIZE];
	memset( msg, 0, MSG_SIZE );
	sprintf( msg, "mvBlueLYNX GMM TOOL - " __DATE__ );

	init_dev( );
	init_from_file( );
	init_gmm( );
	load_gmm_file( );
	init_gui( argc, argv, msg );

	pgUpdate( );

	start_tool( process_flag );
	pgEventLoop( );

	close_dev( );

	return 0;
}

//----------------------------------------------------------------------
//----------------------------------------------------------------------



