#! /bin/make
###########################################################################
#--------------------------------------------------------------------------
# Makefile for the 'pgtools' module,
# == DO NOT CHANGE !!! ==
#--------------------------------------------------------------------------
###########################################################################

TARGET := $(shell basename `pwd`)
OSTYPE := $(shell uname | cut -d _ -f 1 | tr [:upper:] [:lower:])

#--------------------------------------------------------------------------
# needed by dynamic libs
#--------------------------------------------------------------------------
MAJOR=1
MINOR=0
BUILD=1

#--------------------------------------------------------------------------
#--------------------------------------------------------------------------
mvIMPACT=../../../..
WORK=$(mvIMPACT)/..

#--------------------------------------------------------------------------
#mvBLUE_PATH=$(WORK)/mvblue
mvBLUE_LIBS_PATH=$(mvBLUE_PATH)/libs

#--------------------------------------------------------------------------
MODULE_NAME=pgtools
LIB_NAME=lib$(MODULE_NAME)

STATIC_LIB=$(LIB_NAME).a
DYNAMIC_LIB=$(LIB_NAME).so
VERSION=$(MAJOR).$(MINOR).$(BUILD)

#--------------------------------------------------------------------------
SOURCES=								\
		pgtools.cpp spinedit.cpp

#--------------------------------------------------------------------------
vpath %.cpp ..

#--------------------------------------------------------------------------
OBJECTS= 								\
		pgtools.o spinedit.o mk_msg.o

#--------------------------------------------------------------------------
HEADERS=*.h

#--------------------------------------------------------------------------
DO_DYNAMIC_LIBS=n

###########################################################################
# compiler
# will be set in 'impact/Makefile.all.inc'
# set	$(CC) 	- for *.c files
# or	$(CXX)	- for *.cpp files
#--------------------------------------------------------------------------
CTYPE=$(CXX)

#--------------------------------------------------------------------------
#--------------------------------------------------------------------------
#--------------------------------------------------------------------------
include $(mvIMPACT)/Makefile.all.inc

#####################include ../../Makefile.mod.inc
#--------------------------------------------------------------------------
ifeq ($(TARGETARCH),ppc)
	ifeq ($(OSTYPE),cygwin)
		LIB_OUT=$(OSTYPE)
	else
		LIB_OUT=$(TARGET)
	endif
else
	LIB_OUT=i386
endif

#--------------------------------------------------------------------------
LIBPATH=$(mvIMPACT)/lib/$(LIB_OUT)

#--------------------------------------------------------------------------
IMPACT_INCFILES=						\
	-I$(mvIMPACT)/include/linux			\
    -I$(mvIMPACT)/include				\

#-------------------------------------------
INCLFILES=								\
	$(GLOBINCFILES)						\
	$(IMPACT_INCFILES)					\
	-I$(mvBLUE_LIBS_PATH)/pgutils		\
	-I..

#--------------------------------------------------------------------------
ifeq ($(DO_DYNAMIC_LIBS),y)
	USE_STATIC_LIBS=
else
	USE_STATIC_LIBS=-DLIB_STATIC
endif

#--------------------------------------------------------------------------
CPPFLAGS=								\
	$(USE_STATIC_LIBS)					\
	-DDBG_START_END=0					\
	$(CPPFLAGS_2)						\
    $(LOCDEFINES)						\
    $(INCLFILES)						\

#--------------------------------------------------------------------------
#--------------------------------------------------------------------------
.PHONY: all strip $(STATIC_LIB) $(DYNAMIC_LIB).$(MAJOR) ltarget

#-------------------------------------------
all:	$(STATIC_LIB) $(DYNAMIC_LIB).$(MAJOR)

#-------------------------------------------
$(STATIC_LIB):	ltarget $(TARGET) $(OBJECTS) $(LIBPATH)
	$(TOOLS)$(AR) rcs $(LIBPATH)/$(STATIC_LIB) $(OBJECTS) $(EXTERN_OBJ)

#-------------------------------------------
ifeq ($(DO_DYNAMIC_LIBS),y)
$(DYNAMIC_LIB).$(MAJOR):	ltarget $(TARGET) $(OBJECTS) $(LIBPATH)
	$(CTYPE) -shared -Wl,-soname,$(DYNAMIC_LIB).$(MAJOR) 								\
		-o $(LIBPATH)/$(DYNAMIC_LIB).$(VERSION) $(OBJECTS) $(EXTERN_OBJ) $(USE_LN_LIBS) -lc
	@( 	cd $(LIBPATH);																	\
		rm -f $(DYNAMIC_LIB) $(DYNAMIC_LIB).$(MAJOR) ;									\
		ln -s $(DYNAMIC_LIB).$(VERSION) $(DYNAMIC_LIB).$(MAJOR) ;						\
		ln -s $(DYNAMIC_LIB).$(MAJOR) $(DYNAMIC_LIB) ;									\
	)

strip: all
	ls -lh $(LIBPATH)/$(DYNAMIC_LIB).$(VERSION)
	$(TOOLS)strip $(LIBPATH)/$(DYNAMIC_LIB).$(VERSION)
	ls -lh $(LIBPATH)/$(DYNAMIC_LIB).$(VERSION)
#-------
else
#-------
$(DYNAMIC_LIB).$(MAJOR):
	@echo "*** No dynamic libs made!! Set 'DO_DYNAMIC_LIBS' to 'y'!!"

strip: all

endif

#-------------------------------------------
clean_mod:
	@rm -f $(OBJECTS) $(LIBPATH)/$(STATIC_LIB) $(LIBPATH)/$(DYNAMIC_LIB)*

#-------------------------------------------
ltarget:
	@mkdir -p $(LIBPATH)

#-------------------------------------------
linfo:
	@echo "WORK          =" $(WORK)
	@echo "TOOLS         =" $(TOOLS)
	@echo "LIBPATH       =" $(LIBPATH)
	@echo "LIB_NAME      =" $(LIB_NAME)
	@echo "STATIC_LIB    =" $(STATIC_LIB)
	@echo "DYNAMIC_LIB   =" $(DYNAMIC_LIB)
	@echo "CTYPE         =" $(CTYPE)

#-------------------------------------------

#--------------------------------------------------------------------------
#--------------------------------------------------------------------------

