//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - mvBlueLYNX demo >>ocrtool<<
// Tue May 20 14:35:47 CEST 2003
//----------------------------------------------------------------------
//----------------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <picogui.h>
#include <system.h>
#include <pgutils.h>

#include <vl_ocr.h>

#include "ocrtool.h"

//-------------------------------------------------------------------
static int ascii = 0;
static pghandle wDisplay, wSegDisplay;

//-------------------------------------------------------------------
int get_chars( int *c, unsigned char *img_buffer, int width, int height, OCR_RESULT *result )
{
	dprintf((" -> " TOOL_PREFIX ": %s\n", __FUNCTION__ ));

	unsigned char *image = NULL;
	char iheader[256], msg[1], *pmsg;
	memset( iheader, 0, 256 );

	int len = sprintf( iheader, "P5\n# ipl Gray test header\n%d %d\n255\n", width, height );

	pgEnterContext( );
	pghandle wApply, wClose, wToolbar, wPopup, wSkipp;
	pghandle wBox, wDummy;
	struct pgEvent *evt;

	wPopup = pgRegisterApp( PG_APP_TOOLBAR, "OCR TEACH", 0 );

	pgNewWidget( PG_WIDGET_BOX, 0, 0 );
	pgNewWidget( PG_WIDGET_LABEL, PG_DERIVE_INSIDE, PGDEFAULT );
	pgSetWidget( PGDEFAULT,
			PG_WP_TEXT, pgNewString( "OCR TEACH" ),
			PG_WP_FONT, pgNewFont( NULL, 16, 0 ),
			0 );

	wToolbar = pgNewWidget( PG_WIDGET_TOOLBAR, 0, 0 );
	pgSetWidget( PGDEFAULT,
			PG_WP_SIDE, PG_S_BOTTOM,
			PG_WP_PUBLICBOX, 1,
			0 );

	wApply = pgNewWidget( PG_WIDGET_BUTTON, PG_DERIVE_INSIDE, wToolbar );
	pgSetWidget( PGDEFAULT,
			PG_WP_TEXT, pgNewString( "Apply" ),
			0 );

	wSkipp = pgNewWidget( PG_WIDGET_BUTTON, 0, 0 );
	pgSetWidget( PGDEFAULT,
			PG_WP_TEXT, pgNewString( "Skip" ),
			0 );

	wClose = pgNewWidget( PG_WIDGET_BUTTON, 0, 0 );
	pgSetWidget( PGDEFAULT,
			PG_WP_TEXT, pgNewString("Close"),
			0 );

	dprintf(( " == " TOOL_PREFIX ": get_chars - ascii: %d\n", result[0].ascii ));

	if( result[0].ascii > 0 )
	{
		sprintf( msg, "%c", result[0].ascii );
		ascii = result[0].ascii;
	}
	else
	{
		sprintf( msg, "?" );
		ascii = '?';
	}

	wDummy = pgNewWidget( PG_WIDGET_BOX, PG_DERIVE_AFTER, wToolbar );
	wDisplay = pgNewWidget( PG_WIDGET_TEXTBOX, PG_DERIVE_INSIDE, wDummy );
	pgSetWidget( PGDEFAULT,
			PG_WP_TEXT, pgNewString( msg ),
			PG_WP_SIDE, PG_S_ALL,
			0 );
			
	pgFocus( wDisplay );

	wBox = pgNewWidget( PG_WIDGET_BOX, PG_DERIVE_AFTER, wDummy  );
	pgSetWidget( PGDEFAULT,
			PG_WP_SIDE, PG_S_TOP,
			PG_WP_MARGIN, 0,
			0 );

	if(( image = (unsigned char*) malloc(len + width * height)) != NULL )
	{
		char str[MAX_OBJ_CNT];
		memset( str, 0, MAX_OBJ_CNT );
		sprintf( str, "  read: %c ==> quality: %d%%", result[0].ascii, (int)( result[0].quality * 100 ));
		memcpy( image + 0, iheader, len );
		memcpy( image + len, img_buffer, width * height );

		wSegDisplay = pgNewWidget( PG_WIDGET_LABEL, PG_DERIVE_INSIDE, wBox );
		pgSetWidget( PGDEFAULT,
				PG_WP_SIDE, PG_S_TOP,
				PG_WP_SIZE, height,
				PG_WP_BITMAP, pgNewBitmap( pgFromMemory( image, len + width * height )),
				PG_WP_TEXT, pgNewString( str ),
				0 );
	}

	for (;;)
	{
		evt = pgGetEvent();

		if( evt->from == wClose )
		{
			if( image != NULL )
				free( image );

			pgLeaveContext( );
			return RET_CLOSE;
		}
		else if( evt->from == wSkipp )
		{
			if( image != NULL )
				free( image );

			pgLeaveContext( );
			return RET_SKIPP;
		}
		else if( evt->from == wApply )
		{
			pmsg = pgGetString( pgGetWidget( wDisplay, PG_WP_TEXT ));
			strncpy( msg, pmsg, 1 );
			ascii = msg[0];

			dprintf(( " == " TOOL_PREFIX ": get_chars - pmsg: >>%s<<, msg: >>%s<< (ascii: %d)\n",
										pmsg, msg, ascii ));

			*c = ascii;

			if( image != NULL )
				free( image );

			pgLeaveContext( );
			return ascii;
		}
	}

	if( image != NULL )
		free( image );

	pgLeaveContext( );
	return RET_ERROR;
}


//----------------------------------------------------------------------
//----------------------------------------------------------------------
